
local trigger_restart = false

local frameid = 0

local _, _, lev = ...
assert(lev)

local bg = CreateFrame("Frame")
bg:SetLayer(-10)

bg:SetAllPoints()

local bglayers = {}
bglayers[1] = CreateFrame("Frame", bg)
bglayers[2] = CreateFrame("Frame", bg)
bglayers[3] = CreateFrame("Frame", bg)
bglayers[1]:SetLayer(0)
bglayers[2]:SetLayer(2)
bglayers[3]:SetLayer(4)

local obscurities = {}
obscurities[1] = CreateFrame("Frame", bg)
obscurities[2] = CreateFrame("Frame", bg)
obscurities[3] = CreateFrame("Frame", bg)
obscurities[4] = CreateFrame("Frame", bg)
obscurities[1]:SetLayer(-1)
obscurities[2]:SetLayer(1)
obscurities[3]:SetLayer(3)
obscurities[4]:SetLayer(5)
obscurities[1]:SetAllPoints()
obscurities[2]:SetAllPoints()
obscurities[3]:SetAllPoints()
obscurities[4]:SetAllPoints()

local dens = 0.5
local opac = 0.7
obscurities[1]:SetBackgroundColor(0.5 * dens, 0.4 * dens, 0.2 * dens, opac)
obscurities[2]:SetBackgroundColor(0.5 * dens, 0.4 * dens, 0.2 * dens, opac)
obscurities[3]:SetBackgroundColor(0.5 * dens, 0.4 * dens, 0.2 * dens, opac)
obscurities[4]:SetBackgroundColor(0.5 * dens, 0.4 * dens, 0.2 * dens, opac)

local function MakeCloudLayer(size, density, vertical, ofs, layer, tex, r, g, b, a)
  local cloudy = CreateFrame("Frame", layer)
  
  local clouds = {}
  
  local ingen = false
  
  local isdust = (tex == "dust")
  local tex = Texture(tex)
  local cloudwidth = tex:GetWidth() * size
  
  function cloudy:Tick()
    if math.random() * 120 < density then
      local yps = math.random() * vertical + ofs
      local xps = -cloudwidth
      if ingen then xps = math.random() * (1050 + cloudwidth) - cloudwidth end
      local xvel = (math.random() + 1) * 0.5 * size
      local cloud = CreateFrame("Texture", self)
      cloud:SetTexture(tex)
      cloud:SetColor(r or 1, g or 1, b or 1, a or 1)
      if math.random() < 0.5 then
        cloud:SetWidth(cloud:GetWidth() * size)
      else
        cloud:SetWidth(cloud:GetWidth() * -size)
        xps = xps + cloudwidth
      end
      cloud:SetHeight(cloud:GetHeight() * size)
      cloud:SetLayer(math.random())
      function cloud:Tick()
        xps = xps + xvel
        if xps > 1050 + cloudwidth then self:Detach() end
        cloud:SetPoint("TOPLEFT", UIParent, "TOPLEFT", xps, yps)
      end
      cloud:Tick()
    end
  end
  
  ingen = true
  local time_to_cycle = (1024 + tex:GetWidth()) / (0.5 * size)
  print(time_to_cycle, size, tex:GetWidth())
  for i = 1, time_to_cycle do
    cloudy:Tick()
  end
  ingen = false
end

MakeCloudLayer(1, 0.7, 80, -50, bglayers[3], "cloud")
MakeCloudLayer(0.75, 1, 160, -50, bglayers[2], "cloud")
MakeCloudLayer(0.5, 1, 260, -50, bglayers[1], "cloud")

MakeCloudLayer(1, 0.3, 80, 550, bglayers[3], "dust", 0.4, 0.3, 0.2, 0.2)
MakeCloudLayer(0.75, 0.3, 80, 475, bglayers[2], "dust", 0.4, 0.3, 0.2, 0.2)
MakeCloudLayer(0.5, 0.3, 80, 400, bglayers[1], "dust", 0.4, 0.3, 0.2, 0.2)

local bgt = {}
bgt[1] = CreateFrame("Texture", bglayers[1])
bgt[2] = CreateFrame("Texture", bglayers[2])
bgt[3] = CreateFrame("Texture", bglayers[3])
bgt[1]:SetPoint("TOPLEFT", UIParent, "TOPLEFT")
bgt[2]:SetPoint("TOPLEFT", UIParent, "TOPLEFT")
bgt[3]:SetPoint("TOPLEFT", UIParent, "TOPLEFT")
bgt[1]:SetTexture("bg3")
bgt[2]:SetTexture("bg2")
bgt[3]:SetTexture("bg1")
bgt[1]:SetLayer(-5)
bgt[2]:SetLayer(-5)
bgt[3]:SetLayer(-5)


local sequences = {
  dude_stand = {len = 1, sloth = 12, prefix = "dude"},
  dude_walk = {len = 2, sloth = 12, prefix = "dude"},
  dude_jump = {len = 1, sloth = 20, prefix = "dude_jump"},
 
  edud_stand = {len = 1, sloth = 12, prefix = "edud"},
  edud_walk = {len = 2, sloth = 12, prefix = "edud"},
  edud_jump = {len = 1, sloth = 20, prefix = "edud_jump"},
}

local function ssg_argh(self)
  return math.mod(math.floor(self.cpos / self.seq.sloth), self.seq.len) + 1
end
local function std_seq_increment(self)
  local t = ssg_argh(self)
  self.cpos = self.cpos + 1
  local n = ssg_argh(self)
  
  if self.seq.steplen then
    t = math.floor(t / self.seq.steplen)
    n = math.floor(n / self.seq.steplen)
  end
  
  if self.cpos_done and self.cpos >= self.cpos_done then self.cpos = self.cpos_done - 1 end
end
local function std_seq_get(self)
  std_seq_increment(self)
  
  local itex
  itex = math.mod(math.floor(self.cpos / self.seq.sloth), self.seq.len) + 1
  
  local resu = self.seq.prefix .. "_" .. itex
  return resu:gsub("jump_1", "2") -- hurf durf
end
local function NewSequence(id)
  assert(sequences[id], id)
  
  local rv = {seq = sequences[id], name = id}
  if rv.seq.norepeat then
    rv.cpos = 0
    rv.cpos_done = rv.seq.sloth * rv.seq.len
  else
    rv.cpos = math.random(rv.seq.len * rv.seq.sloth)
  end
  rv.get = std_seq_get
  
  return rv
end


loadfile("scaffold.lua")()
loadfile("terra.lua")()
loadfile("worldparams.lua")()

local terra = terra_init(mappieces, entities)
terra.load(assert(io.snatch(lev == "playtest" and "playtest.lev.lua" or "level_" .. lev .. ".lev.lua"), lev))
local gameworld = CreateFrame("Frame")
gameworld:SetAllPoints()  
gameworld:SetCoordinateScale(0, 0, 64)
function gameworld:Draw()
  terra.render()
end

local scaffold = scaffold_init()
terra.scaffoldize(scaffold.InsertLine)

local players = {}
local exitway
local gizmos = {}
local doors = {}

local orbs_light_remaining, orbs_dark_remaining = 0, 0

local orbs_attached = {}


local function collide(one, two)
  return math.abs(two.x - one.x) * 2 <= two.width + one.width and math.abs(two.y - one.y) * 2 <= two.height + one.height
end
local function cpt(x, s, e)
  return x >= s and x <= e
end
local function contained(one, two, boost)
  local bost = boost and 0.1 or 0
  local osx, osy, oex, oey = one.x - one.width / 2, one.y - one.height / 2, one.x + one.width / 2, one.y + one.height / 2
  local tsx, tsy, tex, tey = two.x - two.width / 2, two.y - two.height / 2 - bost, two.x + two.width / 2, two.y + two.height / 2 + bost
  return cpt(osx, tsx, tex) and cpt(oex, tsx, tex) and cpt(osy, tsy, tey) and cpt(oey, tsy, tey)
end

local function playerconflict(x, y, two)
  local tsx, tsy, tex, tey = two.x - two.width, two.y - two.height, two.x + two.width, two.y + two.height
  return cpt(x, tsx, tex) and cpt(y, tsy, tey)
end

local function intersect(one, two)
  local hafw, hafh = (one.width + two.width) / 2, (one.height + two.height) / 2
  local tsx, tsy, tex, tey = two.x - hafw, two.y - hafh, two.x + hafw, two.y + hafh
  return cpt(one.x, tsx, tex) and cpt(one.y, tsy, tey)
end

local function corpsify(target)
  target.bouncefactor = 0.55
  target.bouncelimit = 0.01
  target.gravity = 1
  target.freefall = true
  target.dead = true
  
  target.think = function ()
    if not target.freefall then
      target.xvel = approach(target.xvel, 0, 0.01)
    end
  end
  target.coro = nil
end


local function CreateShifter(magnitude, frequency, loose)
  local rv = {}
  function rv:GenPoint(orig)
    if loose then
      return {orig[1] + math.random() * magnitude * 2 - magnitude, math.random() * frequency + frequency / 2}
    else
      return {math.random() * magnitude * 2 - magnitude, math.random() * frequency + frequency / 2}
    end
  end
  table.insert(rv, rv:GenPoint({0, 0}))
  table.insert(rv, rv:GenPoint(rv[1]))
  table.insert(rv, rv:GenPoint(rv[2]))
  table.insert(rv, rv:GenPoint(rv[3]))
  
  rv.cpos = rv[2][2] / 2
  
  function rv:Increment(frames)
    rv.cpos = rv.cpos + frames
    while rv.cpos > rv[2][2] do
      rv.cpos = rv.cpos - rv[2][2]
      table.remove(rv, 1)
      table.insert(rv, rv:GenPoint(rv[3]))
    end
    
    return cubic(rv[1][1], rv[2][1], rv[3][1], rv[4][1], rv.cpos / rv[2][2]) 
  end
  
  return rv
end


local sparkshader
do
  local vertex = glutil.Shader("VERTEX", [[
    attribute vec2 position;
    varying vec2 position_use;
    
    varying float alpha;
    
    void main()
    {
      gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
      
      position_use = position;
      
      vec3 normal = normalize(gl_NormalMatrix * gl_Normal);
      alpha = abs(dot(normal, vec3(0, 0, 1)));
      alpha = max((alpha * alpha - 0.2) / 0.8, 0.0);
    }
  ]])
  local fragment = glutil.Shader("FRAGMENT", [[
    varying vec2 position_use;
    
    varying float alpha;
    
    uniform bool inverted;
    
    void main()
    {
      float dis = length(position_use);
      
      vec4 point1 = vec4(1, 1, 1, alpha);
      vec4 point2 = vec4(1, 1, 1, 0);
      vec4 point3 = vec4(0, 0, 0, 0);
      vec4 point4 = vec4(0, 0, 0, alpha / 2.0);
      vec4 point5 = vec4(0, 0, 0, 0);
      
      if(dis < 0.8) {
        gl_FragColor = mix(point1, point2, (dis - 0.0) / 0.8);
      } else if(dis < 0.9) {
        gl_FragColor = mix(point3, point4,(dis - 0.8) / 0.1);
      } else if(dis < 1.0) {
        gl_FragColor = mix(point4, point5,(dis - 0.9) / 0.1);
      } else {
        gl_FragColor = point5;
      }
      
      if(inverted) {
        gl_FragColor = gl_FragColor * vec4(-1, -1, -1, 1) + vec4(1, 1, 1, 0);
      }
    }
  ]])
  sparkshader = glutil.Program()
  glutil.AttachShader(sparkshader, vertex)
  glutil.AttachShader(sparkshader, fragment)
  glutil.LinkProgram(sparkshader)
  glutil.VertexAttribInit(sparkshader, "position")
end



local mergeprocs = {}
impose_standard_ai(mergeprocs)


local function boxit(targ, lines)
  local sx, sy, ex, ey = targ.x - targ.width / 2, targ.y - targ.height / 2, targ.x + targ.width / 2, targ.y + targ.height / 2
  -- then we turn our box back on
  lines[1].sx, lines[1].sy, lines[1].ex, lines[1].ey = sx, sy, ex, sy
  lines[2].sx, lines[2].sy, lines[2].ex, lines[2].ey = sx, sy, sx, ey
  lines[3].sx, lines[3].sy, lines[3].ex, lines[3].ey = ex, sy, ex, ey
  lines[4].sx, lines[4].sy, lines[4].ex, lines[4].ey = sx, ey, ex, ey
end
function NewMonster(monster, id)
  local ent = scaffold.Entity(monster.x, monster.y)
  local self = ent
  
  ent.lines = {{}, {}, {}, {}}
  
  ent.width, ent.height = entities[monster.id].width, entities[monster.id].height
  ent.sprite = CreateFrame("Texture", gameworld, "New monster name " .. monster.id)
  ent.sprite:SetTexture(entities[monster.id].tex)
  ent.sprite:SetWidth(ent.width)
  ent.sprite:SetHeight(ent.height)
  ent.sprite:SetColor(entities[monster.id].r, entities[monster.id].g, entities[monster.id].b)
  ent.sprite:SetLayer(1000)

  if not entities[monster.id].flying and not entities[monster.id].not_real then
    scaffold.ground_anchor(ent)
  end
  
  ent.sprite:SetPoint("CENTER", UIParent, "TOPLEFT", ent.x, ent.y)
  ent.sprite:Show()
  
  boxit(ent, ent.lines)
  
  if monster.id == "robert" then
    players[1] = ent
  elseif monster.id == "trebor" then
    players[2] = ent
  elseif monster.id:find("orb_") then
    if monster.id == "orb_white" then
      orbs_light_remaining = orbs_light_remaining + 1
      ent.orb_light = true
    elseif monster.id == "orb_black" then
      orbs_dark_remaining = orbs_dark_remaining + 1
      ent.orb_dark = true
    end
    
    ent.sprite:Detach()
    
    local angs = {}
    for i = 1, 30 do
      table.insert(angs, CreateShifter(360, 1500, true))
    end
    
    ent.sprite = CreateFrame("Frame", gameworld)
    function ent.sprite:Render()
      gl.Disable("DEPTH_TEST")
      gl.DepthFunc("NEVER")
      gl.Disable("CULL_FACE")
      
      gl.MatrixMode("MODELVIEW")
      gl.PushMatrix()
      gl.Translate(ent.x, ent.y, 0)
      
      glutil.UseProgram(sparkshader)
      glutil.UniformI(sparkshader, "inverted", (monster.id == "orb_black") and 1 or 0)
      
      gl.Color(1.0, 1.0, 1.0, 0.5)
      
      for i = 0, 9 do
        local dep = 1 + i * 0.3
        gl.Rotate(angs[i * 3 + 1]:Increment(1), 1, 0, 0)
        gl.Rotate(angs[i * 3 + 2]:Increment(1), 0, 1, 0)
        gl.Rotate(angs[i * 3 + 3]:Increment(1), 0, 0, 1)
        
       -- gl.Rotate(-1, 1, 0, 0)
       
        gl.Begin("QUADS")
        gl.Normal(0, 0, 1)
        glutil.VertexAttrib(sparkshader, "position", -1, -1)
        gl.Vertex(-dep, -dep)
        glutil.VertexAttrib(sparkshader, "position", -1, 1)
        gl.Vertex(-dep, dep)
        glutil.VertexAttrib(sparkshader, "position", 1, 1)
        gl.Vertex(dep, dep)
        glutil.VertexAttrib(sparkshader, "position", 1, -1)
        gl.Vertex(dep, -dep)
        gl.End()
      end
      
      glutil.UseProgram()
      
      gl.PopMatrix()
    end
    
    local pdx = CreateShifter(4, 3000, false)
    local pdy = CreateShifter(4, 3000, false)
    
    function ent:attach_to_player(player)
      function ent.sprite:Tick() -- hahahahhahahaha
        ent.x = lerp(0.01, ent.x, player.x + pdx:Increment(1))
        ent.y = lerp(0.01, ent.y, player.y + pdy:Increment(1))
      end
      table.insert(orbs_attached, ent)
    end
    function ent:obliterate_player(player)
      function ent.sprite:Tick()
        ent.x = lerp(0.05, ent.x, player.x)
        ent.y = lerp(0.05, ent.y, player.y)
        
        local dx, dy = ent.x - player.x, ent.y - player.y
        dx, dy = dx * dx, dy * dy
        if dx + dy < 1 then
          trigger_restart = true
          
          trigger_restart_color = (monster.id == "orb_black") and 0 or 1
          
          if not self.sounded then
            PlaySound("orb_death", 0.4)
            self.sounded = true
          end
        end
      end
    end
    function ent:collide_with(target)
      print("collide with")
      function ent.sprite:Tick()
        ent.x = lerp(0.05, ent.x, target.x)
        ent.y = lerp(0.05, ent.y, target.y)
        
        local dx, dy = ent.x - target.x, ent.y - target.y
        dx, dy = dx * dx, dy * dy
        if dx + dy < 1 then
          if not ent.annihilated and not target.annihilated then
            ent.annihilated = true
            target.annihilated = true
            orbs_light_remaining = orbs_light_remaining - 1
            orbs_dark_remaining = orbs_dark_remaining - 1
            for _, v in ipairs(doors) do
              v:Oblit()
            end
            orbcount_resync()
            ent.sprite:Detach()
            target.sprite:Detach()  -- done!
            PlaySound("orb_combine", 0.4)
            
            local flashframe = CreateFrame("Frame")
            flashframe:SetAllPoints()
            flashframe:SetBackgroundColor(1, 1, 1)
            
            mergeprocs:Tick_AddCoro(function ()
              coroutine.pause(5)
              flashframe:Detach()
            end)
          end
        end
      end
    end
  elseif monster.id:find("door") then
    table.insert(doors, ent)
    
    for _, v in pairs(ent.lines) do
      scaffold.InsertDynamicLine(v)
    end
    
    local dcount = entities[monster.id].tex:match("door(%d)")
    assert(dcount)
    function ent:Oblit()
      dcount = dcount - 1
      
      if dcount <= 0 then
        for _, v in pairs(ent.lines) do
          scaffold.RemoveDynamicLine(v)
        end
        ent.sprite:Hide()
      else
        ent.sprite:SetTexture("door" .. dcount, true)
        ent.sprite:SetWidth(ent.width)
        ent.sprite:SetHeight(ent.height)
      end
    end
  elseif monster.id == "exit" then
    exitway = ent
  end
  
  return ent
end

for id, v in ipairs(terra.entities()) do
  local nm = NewMonster(v, id)
  
  gizmos[nm] = true
end

function playerize(player, reversed)
  local walk_top_speed = 8 / 60
  local run_top_speed = 8 / 60
  local jump_top_speed = 8 / 60
  local start_accel = 0.01
  local stop_accel = 0.02
  local stop_accel_air = 0.0040
  
  player.gravitydirection = (reversed and -1 or 1)
  player.gravitymagnitude = 0.012
  
  local jump_yvel = 0.3 * player.gravitydirection
  
  local jumplift_grav = 0.7
  local jumpdown_grav = 0.7

  player.mirror = true
  player.direction = 1
  
  
  
  player.sprite:SetLayer(1)
  
  function player:mover(x, y, jumpy)
    if self.dead then x = 0 y = 0 jumpy = false end
    
    if x ~= 0 then
      if self.state == "stopped" then
        self.state = "running"
      end
      
      self.direction = x / math.abs(x)
    elseif self.invincibility ~= true then
      local stop_acel = (self.freefall and stop_accel_air or stop_accel)
      if stop_acel > math.abs(self.xvel) then
        self.xvel = 0
        if not self.freefall then self.state = "stopped" end
      else
        if self.xvel > 0 then stop_acel = -stop_acel end
        self.xvel = self.xvel + stop_acel
      end
    end
    
    if self.gravity < jumpdown_grav then
      self.gravity = self.gravity + 0.025
    end
    
    if y < 0 and not self.freefall and jumpy then
      self.freefall = true
      self.gravity = jumplift_grav
      self.yvel = -jump_yvel
      self.state = "run_jump"
    end
    
    if y >= 0 and self.freefall and self.yvel * player.gravitydirection < 0 and self.gravity > jumpdown_grav then
      self.yvel = self.yvel / 2
      self.gravity = jumpdown_grav
    end
    
    if self.state == "run_jump" and self.yvel * player.gravitydirection > 0 then
      self.state = "run_jump_fall"
      self.gravity = jumpdown_grav
    end
    
    if x > 0 then
      self.xacel = start_accel
    elseif x < 0 then
      self.xacel = -start_accel
    else
      self.xacel = 0
    end
    
    if self.xacel * self.xvel < 0 then
      self.xacel = self.xacel * 2
    end
    
    if self.invincibility ~= true then
      local top_speed
      if self.state == "stopped" or self.state == "end_run_jump" then
        top_speed = walk_top_speed
      elseif self.state == "running" then
        top_speed = run_top_speed
      elseif self.state == "run_jump" or self.state == "run_jump_fall" or self.state == "start_run_jump" then
        top_speed = jump_top_speed
      else
        top_speed = 1000
      end
      
      local expected_speed = self.xvel + self.xacel
      if math.abs(expected_speed) > top_speed then
        self.xacel = (top_speed - math.abs(expected_speed)) * (expected_speed / math.abs(expected_speed))
      end
    end
    
    local img
    if self.freefall then
      img = "_jump"
    elseif self.xvel == 0 then
      img = "_stand"
    else
      img = "_walk"
    end
    
    local prefix = "dude"
    if reversed then prefix = "edud" end
    
    if self.current_tex ~= img then
      self.current_tex = img
      self.tex = NewSequence(prefix .. img)
    end
    
    self.sprite:SetTexture(self.tex:get(), true)
    if self.direction < 0 then
      self.sprite:SetWidth(-self.width * 2)
    else
      self.sprite:SetWidth(self.width * 2)
    end
    self.sprite:SetHeight(self.height * 2)
  end
  function player:cycle(dx, dy, jump)
    player:mover(dx, dy, jump)  -- first we move
    player:tick() -- then we tick
  end
end

function orbcount_resync()
  if orbs_light_remaining == 0 and orbs_dark_remaining == 0 then
    exitway.sprite:SetTexture("exit")
  else
    exitway.sprite:SetTexture("exit_closed")
  end
  exitway.sprite:SetWidth(exitway.width)
  exitway.sprite:SetHeight(exitway.height)
end
orbcount_resync()

playerize(players[1])
players[1].orb_light_absorb = true
playerize(players[2], true)
players[1].orb_dark_absorb = true

local function CreatePlayer()
  local play = NewMonster({x = entry.x, y = entry.y, id = "robert"})
  playerize(play)
  return play
end

local dying
local activeplayer = players[1]
local inactiveplayer = players[2]
local process = coroutine.wrap(function ()
  local playerlife = nil
  
  local playerwin = false
  
  while true do
  
    -- check to see if they're at the exit
    if orbs_light_remaining == 0 and orbs_dark_remaining == 0 then
      local wins = 0
      for _, k in pairs(players) do
        if contained(k, exitway, true) then
          wins = wins + 1
        end
      end
      if wins == 2 then
        message("yay")
      end
    end
    
    -- absorb orbs
    for _, player in pairs(players) do
      for item, _ in pairs(gizmos) do
        if item.orb_light or item.orb_dark then
          if intersect(player, item) then
            if player.orb_light_absorb == item.orb_light then
              PlaySound("orb_pickup", 0.4)
              item:attach_to_player(player)
            else
              item:obliterate_player(player)
            end
            
            gizmos[item] = nil
          end
        end
      end
    end
    
    -- recombine orbs
    if intersect(players[1], players[2]) then
      if #orbs_attached > 0 then
        local dorbs = orbs_attached
        orbs_attached = {}
        mergeprocs:Tick_AddCoro(function ()
          while #dorbs > 0 do
            local white
            local black
            local norbs = {}
            
            for _, v in ipairs(dorbs) do
              if v.orb_light and not white then
                white = v
              elseif v.orb_dark and not black then
                black = v
              else
                table.insert(norbs, v)
              end
            end
            
            dorbs = norbs
            
            if white and black then
              white:collide_with(black)
              black:collide_with(white)
            elseif white then
              white:obliterate_player(players[2])
            elseif black then
              black:obliterate_player(players[1])
            end
            
            coroutine.pause(60)
          end
        end)
      end
    end
    
    if WasKeyPressed("r") then
      message("restart")
    end
    
    -- swap players
    if WasKeyPressed("z") then
      activeplayer, inactiveplayer = inactiveplayer, activeplayer
    end
    
    if not playerwin then
      local dx, dy = 0, 0
      local speed = 1
      
      if IsKeyDownFrame("arrow_up") or IsKeyDownFrame(" ") then dy = dy - speed end
      if IsKeyDownFrame("arrow_left") then dx = dx - speed end
      if IsKeyDownFrame("arrow_right") then dx = dx + speed end
      
      local jump = WasKeyPressed("arrow_up") or WasKeyPressed(" ")
      
      activeplayer:cycle(dx, dy, jump)
      inactiveplayer:cycle(0, 0, false)
      
      if true and (activeplayer.y > 40 or inactiveplayer.y > 40 or activeplayer.y < -40 or inactiveplayer.y < -40) then
        local flashframe = CreateFrame("Frame")
        flashframe:SetAllPoints()
        flashframe:SetBackgroundColor(1, 1, 1)
        
        PlaySound("fall_death", 0.4)
        dying = true
        
        mergeprocs:Tick_AddCoro(function ()
          coroutine.pause(5)
          message("restart")
        end)
      end
    end
    
    coroutine.yield()
  end
end)

local deathsplat = nil
function tick_loop(...)
  if trigger_restart and not deathsplat then
    deathsplat = coroutine.wrap(function ()
      if trigger_restart_mega then
        message("restart")
        return
      end
      
      local deathi = CreateFrame("Frame")
      deathi:SetLayer(1000)
      deathi:SetAllPoints()
      
      for i = 1, 30 do
        deathi:SetBackgroundColor(trigger_restart_color, trigger_restart_color, trigger_restart_color, math.pow(i / 30, 3))
        coroutine.yield()
      end
      
      message("restart")
    end)
  elseif deathsplat then
    deathsplat()
  end
  
  mergeprocs:Tick()
  process()
end


GlorpController("repopulate_menu", {
  {text = "Restart level", event = function () trigger_restart = true trigger_restart_mega = true end},
})
