
ShowMouseCursor(false)

local _, _, levoverride, firstlev = ...

local tick -- clev.tick_loop

--[[local revrembox = CreateFrame("Frame")
local revremsigil = CreateFrame("Text", revrembox)
revremsigil:SetText("R = restart")
revremsigil:SetSize(20)
revremsigil:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -40, -40)
revremsigil:SetColor(1, 1, 1)
revrembox:SetPoint("TOPLEFT", revremsigil, "TOPLEFT", -20, -15)
revrembox:SetPoint("BOTTOM", revremsigil, "BOTTOM", nil, 15)
revrembox:SetPoint("RIGHT", revremsigil, "RIGHT", 20, nil)]]

core_segments = persistence.load("segments")

loadfile("level_list.lua")()

--[[
local text_bg = CreateFrame("Frame")
local text_fg = CreateFrame("Frame", text_bg)
local text = CreateFrame("Text_Multiline", text_fg)
local text_butan = CreateFrame("Text", text_fg)
text:SetPoint("TOPLEFT", text_fg, "TOPLEFT", 10, 10)
text:SetPoint("RIGHT", text_fg, "RIGHT", -10, nil)
text:SetHeight(1000)
text:SetColor(0, 0, 0)
text_fg:SetPoint("CENTER", UIParent, "CENTER", 0, 300)
text_fg:SetWidth(500)
text_fg:SetHeight(100)
text_fg:SetBackgroundColor(0.8, 0.8, 0.9)
text_bg:SetPoint("TOPLEFT", text_fg, "TOPLEFT", -10, -10)
text_bg:SetPoint("BOTTOMRIGHT", text_fg, "BOTTOMRIGHT", 10, 10)
text_bg:SetBackgroundColor(0.2, 0.2, 0.3)
text_bg:Hide()
text_butan:SetPoint("BOTTOMRIGHT", text_fg, "BOTTOMRIGHT", -10, -10)
text_butan:SetText("Press space to continue.")
text_butan:SetSize(20)



local function play_text(canned)
  local ticktemp = tick
  tick = nil
  
  text_bg:Show()

  for _, v in pairs(canned) do
    text:SetText(v)
    coroutine.yield()
    while not WasKeyPressed("enter") and not WasKeyPressed("space") and not WasKeyPressed(" ") do
      coroutine.yield()
    end
  end
  
  tick = ticktemp
  text_bg:Hide()
end

]]

local function run_level(lev)
  while true do
    assert(lev.name)
    local cl = runuifile("level.lua", lev.name)
    
    local message
    
    cl.message = function (message_in) message = message_in coroutine.yield() --[[ this yield is so we handle each message individually - we won't actually yield again so this doesn't cause framerate hitches, classy no ]] end
    
    tick = function (...) cl.tick_loop(...) end
    
    while true do
      message = nil
      while not message do
        coroutine.yield()
      end
      
      --[[if message == "player_spawned" then
        if textses[lev.name .. "_intro"] and not spawned_played then
          spawned_played = true
          play_text(textses[lev.name .. "_intro"])
        end
        
        if current_phase > 1 and textses[lev.name .. "_mid"] and not mid_played then
          mid_played = true
          play_text(textses[lev.name .. "_mid"])
        end
      elseif message[1] == "splat" then
        traces = message[2]
        if not core_segments.timedeath then
          core_segments.timedeath = true
          play_text(textses["first_time"])
        elseif current_phase > 1 and not core_segments.reversabled then
          core_segments.reversabled = true
          play_text(textses["reversable"])
        end
        break
      elseif message[1] == "whoops" then
        if not core_segments.paradoxdeath then
          core_segments.paradoxdeath = true
          play_text(textses["first_paradox"])
        elseif current_phase > 1 and not core_segments.reversabled then
          core_segments.reversabled = true
          play_text(textses["reversable"])
        else
          play_text({"Boom!"})
        end
        break
      else
      elseif message[1] == "reverse" then
        current_phase = #message[2] + 1
        traces = message[2]
        break
      else]]
      
      if message == "yay" then
        if textses[lev.name .. "_exit"] then
          play_text(textses[lev.name .. "_exit"])
        end
        
        return 
      elseif message == "restart" then
        break
      else
        assert(false)
      end
    end
    
    cl.UIRoot:Detach()
  end
end


local logic


if levoverride then
  logic = coroutine.wrap(function()
    while true do
      run_level({name = levoverride, phases = 1000})
    end
  end)
else
  logic = coroutine.wrap(function()
    for i = (firstlev or 1), #core_levels do
      run_level(core_levels[i])
      core_segments[core_levels[i].name] = true
      persistence.save()
    end
    
    GlorpController("exit_game")
  end)
end

function tick_loop(...)
  logic()
  if tick then tick(...) end
end
