

local major = gl.GetString("VERSION"):match("^(%d+).*")
print(major)
if tonumber(major) < 2 then
  local tex = CreateFrame("Text_Multiline")
  
  tex:SetText("This game requires some nontrivial graphics card capabilities. Unfortunately, your graphics card doesn't seem to be capable of them. You might be able to solve this by updating your drivers, but it's also possible that you simply don't have a graphics card that is able to do them.\n\nThis means you can't play the game. Sorry! I'd really love it if you could, but with two days to write an entire game, certain things (like compatibility) must be sacrificed. Come back next month for another game!\n\n(If you're curious, this game requires OpenGL 2.0.)")
  tex:SetPoint("CENTER", UIParent, "CENTER")
  tex:SetWidth(600)
  tex:SetColor(1, 1, 1)
  tex:ForceHeight()

  menu.ok_text:Hide()
  menu.exit_text:Hide()
  
  disable_anchor()
  
  return
end



ShowMouseCursor(true)

core_segments = persistence.load("segments")
if not core_segments.toplev then core_segments.toplev = 1 end

loadfile("level_list.lua")()

local tex = CreateFrame("Text_Multiline")
tex:SetPoint("TOPRIGHT", UIParent, "TOPRIGHT", -20, 50)
tex:SetPoint("LEFT", UIParent, "LEFT", 250, nil)
tex:SetHeight(1000)
tex:SetText(
[[Switch characters with Z.

Bring the characters together to combine and annihilate orbs. Annihilate all the orbs to open the Ramsgate.

Touch an orb of the wrong color, and you die. Combine orbs unevenly, and you die.

Get everyone to the end to save the world.]])



local cpt

local pointer = CreateFrame("Text")
pointer:SetText("- ")
pointer:SetColor(1, 1, 1)

local spots = {}

local function resynch_pointer()
  pointer:SetPoint(1, 0.5, spots[cpt], 0, 0.5, -3, 0)
end


local found_next = false

local anchor = CreateFrame("Frame")
anchor:SetPoint("BOTTOMLEFT", UIParent, "TOPLEFT", 50, 50)
for i = 1, #core_levels do
  local but = CreateFrame("Button")
  local ite = CreateFrame("Text", but)
  ite:SetPoint("TOPLEFT", anchor, "BOTTOMLEFT", 0, 5)
  local name = core_levels[i].name
  ite:SetText(name)
  ite:SetSize(40)
  
  if core_segments[name] then
    ite:SetColor(0.5, 0.5, 0.8)
  else
    if found_next then
      ite:SetColor(0.2, 0.2, 0.2)
    else
      ite:SetColor(1, 1, 1)
      found_next = true
      cpt = i
    end
  end
  
  table.insert(spots, ite)
  function but:Click()
    cpt = i
    resynch_pointer()
  end
  anchor = ite
end

if not cpt then cpt = 1 end


resynch_pointer()



function menu.ok_button:Click()
  GlorpController("start_game", nil, cpt, core_levels, core_segments)
end

menu.ok_text:SetPoint("CENTER", UIParent, "CENTER", 0, 200)
menu.ok_text:SetText("Start")

menu.exit_text:SetPoint("CENTER", UIParent, "CENTER", 0, 300)

menu.ok_text:SetPoint(0.5, nil, UIParent, 0.5, nil)
menu.exit_text:SetPoint(0.5, nil, UIParent, 0.5, nil)

menu.ok_text:SetPoint(nil, 0.5, UIParent, nil, 0.5, nil, 100)
menu.exit_text:SetPoint(nil, 0.5, UIParent, nil, 0.5, nil, 200)


local credits = CreateFrame("Text")
credits:SetText("Music: Kirsty Hawkshaw - In Between. Available at Magnatune.")
local credits2 = CreateFrame("Text")
credits2:SetText("Licensed under Creative Commons by-nc-sa v1.0.")
local credits3 = CreateFrame("Text")
credits3:SetText("This game is provided under Creative Commons by-nc-sa v1.0.")

credits3:SetPoint("BOTTOMRIGHT", UIParent, "BOTTOMRIGHT", -10, -10)
credits2:SetPoint("BOTTOMRIGHT", credits3, "TOPRIGHT", 0, -5)
credits:SetPoint("BOTTOMRIGHT", credits2, "TOPRIGHT", 0, -5)

credits:SetColor(1, 1, 1)
credits2:SetColor(1, 1, 1)
credits3:SetColor(1, 1, 1)

credits:SetSize(15)
credits2:SetSize(15)
credits3:SetSize(15)
